/*
 * DS18B20Գ
 * 
 * ;LCD1602Գ
 * 
 * 									ע
 * Huafeng Lin			2012/04/21			
 * Huafeng Lin			2012/04/21			޸
 * 
 */

#include <reg51.h>
#include <intrins.h>
/*********************************LCD岿********************************/
//뷽ʽ
#define LCD_AC_AUTO_INCREMENT     0x06         //ݶд,ACԶһ
#define LCD_AC_AUTO_DECREASE      0x04         //ݶд,ACԶһ
#define LCD_MOVE_ENABLE           0x05         //ݶд,ƽ
#define LCD_MOVE_DISENABLE        0x04         //ݶд,治
#define LCD_GO_HOME               0x02         //AC=0,ꡢHOMEλ
//ʾ꼰˸
#define LCD_DISPLAY_ON            0x0C         //ʾ
#define LCD_DISPLAY_OFF           0x08         //ʾ
#define LCD_CURSOR_ON             0x0A         //ʾ
#define LCD_CURSOR_OFF            0x08         //겻ʾ
#define LCD_CURSOR_BLINK_ON       0x09         //˸
#define LCD_CURSOR_BLINK_OFF      0x08         //겻˸
//ꡢƶ,ӰDDRAM
#define LCD_LEFT_MOVE             0x18         //LCDʾһλ
#define LCD_RIGHT_MOVE            0x1C         //LCDʾһλ
#define LCD_CURSOR_LEFT_MOVE      0x10         //һλ
#define LCD_CURSOR_RIGHT_MOVE     0x14         //һλ
//ʽ
#define LCD_DISPLAY_DOUBLE_LINE   0x38         //ʾ
#define LCD_DISPLAY_SINGLE_LINE   0x30         //ʾ
#define LCD_CLEAR_SCREEN  0X01   //
/***********************LCD1602ַ******************************/
#define LINE1_HEAD    0x80   //һDDRAMʼַ
#define LINE2_HEAD    0xc0   //ڶDDRAMʼַ
#define LINE1         0      //һ
#define LINE2         1      //ڶ
#define LINE_LENGTH   16     //ÿеַ
/***********************LCD1602Ŷ**************************/
#define LCDIO     P2         //P2LCD1602ݿ
sbit LCD_RS=P0^2;        
sbit LCD_RW=P0^1;        
sbit LCD_EN=P0^0;
sbit LCD_BUSY=LCDIO^7;
 /**********************صĶ*********************************/
#define HIGH 1
#define LOW 0  
#define TURE 1
#define FALSE 0
#define uchar 	unsigned char
#define uint 	unsigned int

sbit DQ=P3^6; 				//ݴ߽ӵƬӦ 
unsigned char tempL=0; 		//ȫֱ
unsigned char tempH=0; 
unsigned int sdata;			//¶ȵ
unsigned char xiaoshu1;		//Сһλ
unsigned char xiaoshu2;		//Сڶλ
unsigned char xiaoshu;		//λС
bit fg=1;        			//¶־ 
/*************************Ǻ*************************/
void LCD_init(void); 
void LCD_send_command(uchar command); 
void LCD_send_data(uchar dat);
void LCD_write_char(uchar x,uchar y,uchar dat);
void LCD_write_string(uchar x,uchar y,char *Data);
void delay_ms(uint n);
void LCD_check_busy(void);
/***********************************************************************/
void Display(void);
/**************LCD1602ĳʼ***************************/
void LCD_init(void)
{
	LCD_send_command(LCD_DISPLAY_DOUBLE_LINE);
	LCD_send_command(LCD_AC_AUTO_INCREMENT|LCD_MOVE_DISENABLE);
	LCD_send_command(LCD_DISPLAY_ON|LCD_CURSOR_OFF);
	LCD_send_command(LCD_CLEAR_SCREEN);
}
/***********************LCD״̬*********************************/
void LCD_check_busy(void)  
{
	do
	{
		LCD_EN=0;
		LCD_RS=0;
		LCD_RW=1;
		LCDIO=0xff;
		LCD_EN=1;
	}
	while(LCD_BUSY==1);
	
	LCD_EN=0;
}
/************LCD1602д*******************************/
void LCD_send_command(uchar command)
{
	LCD_check_busy();
	LCD_RS=LOW;
	LCD_RW=LOW;
	LCD_EN=HIGH;
	LCDIO=command;
	LCD_EN=LOW;
}
/*****************LCD1602д**************************/
void LCD_send_data(uchar dat)
{
	LCD_check_busy();
	LCD_RS=HIGH;
	LCD_RW=LOW;
	LCD_EN=HIGH;
	LCDIO=dat;
	LCD_EN=LOW;
}
/***********************LCD1602ʾַ*********************************/
void LCD_write_char(uchar x,uchar y,uchar dat)
{
	unsigned char address;
	if (y == LINE1)
		address = LINE1_HEAD + x;
	else
		address = LINE2_HEAD + x;
	LCD_send_command(address);
	LCD_send_data(dat);
}
/******************LCD1602ʾַ*********************/
void LCD_write_string(uchar x,uchar y,uchar *Data)
{
	if(y==LINE1)
	{
		if(x<LINE_LENGTH)
		{
			LCD_send_command(LINE1_HEAD+x);
			for(;x<LINE_LENGTH&&*Data!='\0';x++)
			{
				LCD_send_data(*(Data++));
			}
			if(*Data!='\0')
			{
				x=0;
				y=LINE2;
			}
		}
	}

	if(y==LINE2)
	{
		LCD_send_command(LINE2_HEAD+x);
		for(;x<LINE_LENGTH&&*Data!='\0';x++)
		{
			LCD_send_data(*(Data++));
		}
	}
}
/********************ʱ***********************************/
void delay_ms(uint n)
{
	uint i,j;
	for(i=n;i>0;i--)
		for(j=0;j<1000;j++)
			;
}



void delay(unsigned char i)
{
	for(i;i>0;i--);
}

void delay1(uchar i)
{
	uchar j,k; 
	for(j=i;j>0;j--)
		for(k=125;k>0;k--);
}

void Init_DS18B20(void) 
{
	unsigned char x=0;
	DQ=1; 					//DQø 
	delay(8); 				//ʱ
	DQ=0; 					//͸λ 
	delay(80); 				//ʱ>480us) 
	DQ=1; 					// 
	delay(5); 				//ȴ15~60us) 
	x=DQ; 					//Xֵжϳʼûгɹ18B20ڵĻX=0X=1 
	delay(20); 
}

//һֽ
ReadOneChar(void)  			//ȴӸ͵ƽ1usϣʹΪߵƽӶź
{
	unsigned char i=0; 		//ÿ̵ĳʱΪ60us֮1usϵĸߵƽָ
	unsigned char dat=0; 
	for (i=8;i>0;i--) 		//һֽ8λ 
	{
		DQ=1; 
		delay(1); 
		DQ=0;
		dat>>=1; 
		DQ=1; 
		if(DQ) 
		dat|=0x80; 
		delay(4);
	} 
	return(dat);
}

//дһֽ
void WriteOneChar(unsigned char dat) 
{ 
	unsigned char i=0; 		//ߴӸߵƽ͵ƽдʼźš15us֮ڽдλ͵ϣ
	for(i=8;i>0;i--) 		//15~60us߽֮вǸߵƽд1д0 
	{
		DQ=0; 				//ڿʼһдǰ1usϵĸߵƽָڡ 
		DQ=dat&0x01; 
		delay(5); 
		DQ=1; 
		dat>>=1;
	} 
	delay(4);
}

//¶ֵλtempL;λtempH;
void ReadTemperature(void) 
{ 
	Init_DS18B20(); 					//ʼ
	WriteOneChar(0xcc); 				//кŵĲ
	WriteOneChar(0x44); 				//¶ת
	delay(125); 						//תҪһʱ䣬ʱ 
	Init_DS18B20(); 					//ʼ
	WriteOneChar(0xcc); 				//кŵĲ 
	WriteOneChar(0xbe); 				//¶ȼĴͷֱֵΪ¶ȵĵλ͸λ 
	tempL=ReadOneChar(); 				//¶ȵĵλLSB
	tempH=ReadOneChar(); 				//¶ȵĸλMSB	
	if(tempH>0x7f)      				//λΪ1ʱ¶Ǹ
	{
		tempL=~tempL;					//תȡһ
		tempH=~tempH+1;       
		fg=0;      						//ȡ¶Ϊʱfg=0
	}
	sdata = tempL/16+tempH*16;      	//
	xiaoshu1 = (tempL&0x0f)*10/16; 		//Сһλ
	xiaoshu2 = (tempL&0x0f)*100/16%10;	//Сڶλ
	xiaoshu=xiaoshu1*10+xiaoshu2; 		//Сλ
}

void Display(void)     
{
	if(fg==1)
	{
		LCD_write_char(0x00,LINE2,(sdata/10)+0x30);
		LCD_write_char(0x01,LINE2,(sdata%10)+0x30);
		LCD_write_char(0x02,LINE2,'.');
		LCD_write_char(0x03,LINE2,xiaoshu1+0x30);
		LCD_write_char(0x04,LINE2,xiaoshu2+0x30);
	}	
	 
	if(fg==0)	//¶Ϊʱʾ
	{
		LCD_write_char(0x00,LINE2,'-');
		LCD_write_char(0x01,LINE2,(sdata/10)+0x30);
		LCD_write_char(0x02,LINE2,(sdata%10)+0x30);
		LCD_write_char(0x03,LINE2,'.');
		LCD_write_char(0x04,LINE2,xiaoshu1+0x30);
		LCD_write_char(0x05,LINE2,xiaoshu2+0x30);
	}
}

void main(void)
{
	LCD_init();
	while(1)
	{
		ReadTemperature();
		Display();
	}
}