/*
 * ʱ(DS1307)ģ
 *
 * AUTHOR			WHAT		DATE
 * Huafeng Lin		created 	2012/12/07
 * Huafeng Lin		modified 	2012/12/07
 *
 */

#include <reg51.h>
#include <intrins.h>
/*********************************LCD岿********************************/
//뷽ʽ
#define LCD_AC_AUTO_INCREMENT     0x06         //ݶд,ACԶһ
#define LCD_AC_AUTO_DECREASE      0x04         //ݶд,ACԶһ
#define LCD_MOVE_ENABLE           0x05         //ݶд,ƽ
#define LCD_MOVE_DISENABLE        0x04         //ݶд,治
#define LCD_GO_HOME               0x02         //AC=0,ꡢHOMEλ
//ʾ꼰˸
#define LCD_DISPLAY_ON            0x0C         //ʾ
#define LCD_DISPLAY_OFF           0x08         //ʾ
#define LCD_CURSOR_ON             0x0A         //ʾ
#define LCD_CURSOR_OFF            0x08         //겻ʾ
#define LCD_CURSOR_BLINK_ON       0x09         //˸
#define LCD_CURSOR_BLINK_OFF      0x08         //겻˸
//ꡢƶ,ӰDDRAM
#define LCD_LEFT_MOVE             0x18         //LCDʾһλ
#define LCD_RIGHT_MOVE            0x1C         //LCDʾһλ
#define LCD_CURSOR_LEFT_MOVE      0x10         //һλ
#define LCD_CURSOR_RIGHT_MOVE     0x14         //һλ
//ʽ
#define LCD_DISPLAY_DOUBLE_LINE   0x38         //ʾ
#define LCD_DISPLAY_SINGLE_LINE   0x30         //ʾ
#define LCD_CLEAR_SCREEN  0X01   //
/***********************LCD1602ַ******************************/
#define LINE1_HEAD    0x80   //һDDRAMʼַ
#define LINE2_HEAD    0xc0   //ڶDDRAMʼַ
#define LINE1         0      //һ
#define LINE2         1      //ڶ
#define LINE_LENGTH   16     //ÿеַ
/***********************LCD1602Ŷ**************************/
#define LCDIO     P2         //P2LCD1602ݿ
sbit LCD_RS=P0^2;        
sbit LCD_RW=P0^1;        
sbit LCD_EN=P0^0;
sbit LCD_BUSY=LCDIO^7;
 /**********************صĶ*********************************/
#define HIGH 1
#define LOW 0  
#define TURE 1
#define FALSE 0
#define uchar 	unsigned char
#define uint 	unsigned int 
/*************************Ǻ*************************/
void LCD_init(void); 
void LCD_send_command(uchar command); 
void LCD_send_data(uchar dat);
void LCD_write_char(uchar x,uchar y,uchar dat);
void LCD_write_string(uchar x,uchar y,char *Data);
void delay_ms(uint n);
void LCD_check_busy(void);
/********************************************************************/

/***************************DS1307ʼ*****************************************************************/
#define Wait1us _nop_();
#define Wait2us {_nop_();_nop_();}
#define Wait4us {Wait2us;Wait2us;}
#define Wait8us {Wait4us;Wait4us;}
#define Wait10us {Wait8us;Wait2us;}
#define WRITEDS1307 0xD0
#define READDS1307 0xD1
sbit SDA=P0^3;	//DS1307 Serial-Data Input pin5
sbit SCL=P0^4;	//DS1307 Serial-Clock Input pin6
/************************************************************/
void I2C_start(void);//I2C start function
void I2C_stop(void);//I2C stop function
//void I2C_send_ack(void);//I2C send responsion function
void I2C_send_noack(void);
void I2C_write_byte(unsigned char IIC_data);//I2C bus write byte function
unsigned char I2C_read_byte(void);//I2C bus read byte function
/***********************************************************************/
void Write1307(unsigned char add,unsigned char dat);//write information to ds1307
unsigned char Read1307(unsigned char add);//read information from ds1307
void Read_RTC(void);//read RTC
void Set_RTC(void);//set RTC
/***********************************************************************/
unsigned char set_rtc_code[7]={0,42,19,5,14,12,12};
code unsigned char rtc_address[7]={0x00,0x01,0x02,0x03,0x04,0x05,0x06};
code unsigned char *day[7]={"Mon","Tue","Wen","Thu","Fri","Sat","Sun"};
unsigned char read_rtc_code[7];
/***********************************************************************/
void Initial(void);//system initize function
void Display(void);//RTC display function
void RtcBCDToBin(void);
unsigned char byte_bintobcd(unsigned char bin);
/***********************************************************************/
void main(void)
{
	Initial();
	while(1)
	{
		delay_ms(10);  
		Read_RTC();
		RtcBCDToBin();
		Display();
	}
}
/***********************************************************************/
void Initial(void)      
{
	LCD_init();
	//Set_RTC();   
}
/***********************************************************************/
void I2C_start(void)
{
	SDA=1;
	SCL=1;
	Wait8us;
	SDA=0;
	Wait8us;
	SCL=0;
}
/***********************************************************************/
void I2C_stop(void)
{
	SDA=0;
	SCL=1;
	Wait8us;
	SDA=1;
	Wait4us;
	SCL=0;
}
/***********************************************************************
void I2C_send_ack(void)
{
	SDA=0;
	SCL=1;
	Wait4us;
	SCL=0;
}
*************************************************************************/
void I2C_send_noack(void)
{
	SDA=1;
	SCL=1;
	Wait4us;
	SCL=0;
}
/***********************************************************************/
void I2C_write_byte(unsigned char IIC_data)
{
	unsigned char i;
	for(i=0;i<8;i++)
	{
		SCL=0;
		if((IIC_data<<i) & 0x80)
			SDA=1;                   //жϷλ
		else SDA=0;
		Wait2us;
		SCL=1;
		Wait4us;
		SCL=0;
	}
	Wait4us;
	SDA=1; //8bit,ͷ׼Ӧλ
	Wait2us;
	SCL=1;
	Wait4us; //sdaݼǴӦλ
	SCL=0; //ǴӦλ Ҫƺʱ
 }
/***********************************************************************/
unsigned char I2C_read_byte(void)
{
	unsigned char i,dat;
	dat=0;
	SDA=1;
	for (i=0;i<8;i++)
	{
		dat=dat<<1;
		SCL=1;
		Wait2us;
		if(SDA==1)
		{
		dat++;
		}
		
		SCL=0; 
	} 
	return (dat);
}
/******************************** DS1307 PART START  ****************/
void Write1307(unsigned char add,unsigned char dat)
{
	I2C_start();
	I2C_write_byte(WRITEDS1307);
	I2C_write_byte(add);
	I2C_write_byte(dat);
	I2C_stop();
}
/***********************************************************************/
unsigned char Read1307(unsigned char add)
{ 
	unsigned char dat;
	I2C_start();
	I2C_write_byte(WRITEDS1307);
	I2C_write_byte(add);
	I2C_start();
	I2C_write_byte(READDS1307);
	dat=I2C_read_byte();
	I2C_send_noack();
	I2C_stop();       
	return (dat);
}
/****************************DS1307ļĴ*******************************************/
void Read_RTC(void)
{
	unsigned char i,*p;
	p=rtc_address;
	for(i=0;i<7;i++)
	{
		read_rtc_code[i]=Read1307(*p);
		p++;
	}
}
/***************************DS1307ĳʼ********************************************/
void Set_RTC(void)
{
	unsigned char i,*p;
	p=rtc_address;
	for(i=0;i<7;i++)
	{
		//Write1307(*p,set_rtc_code[i]);
		Write1307(*p,byte_bintobcd(set_rtc_code[i]));
		p++; 
	}
} 
/********************  OTHER PART   ******************************/
unsigned char byte_bintobcd(unsigned char bin)
{
	unsigned char ret;
	bin&=0x7f;
	bin%=100;
	ret=bin/10;
	ret <<=4;
	ret|=bin%10;
	return ret;
}
unsigned char byte_bcdtobin(unsigned char bcd)
{
	unsigned char ret;
	ret=bcd & 0x0f;
	ret+=(bcd>>4)*10;
	return ret;		
}
void RtcBCDToBin(void)
{
	unsigned char i;
	for(i=0;i<7;i++)
		read_rtc_code[i]=byte_bcdtobin(read_rtc_code[i]);
}
void Display(void)     
{
	LCD_write_char(0x0f,LINE2,(read_rtc_code[0]%10)+0x30);
	LCD_write_char(0x0e,LINE2,(read_rtc_code[0]/10)+0x30);
	LCD_write_char(0x0c,LINE2,(read_rtc_code[1]%10)+0x30);
	LCD_write_char(0x0b,LINE2,(read_rtc_code[1]/10)+0x30);
	LCD_write_char(0x09,LINE2,(read_rtc_code[2]%10)+0x30);
	LCD_write_char(0x08,LINE2,(read_rtc_code[2]/10)+0x30);
	LCD_write_char(0x09,LINE1,(read_rtc_code[4]%10)+0x30);
	LCD_write_char(0x08,LINE1,(read_rtc_code[4]/10)+0x30);
	LCD_write_char(0x06,LINE1,(read_rtc_code[5]%10)+0x30);
	LCD_write_char(0x05,LINE1,(read_rtc_code[5]/10)+0x30);
	LCD_write_char(0x03,LINE1,(read_rtc_code[6]%10)+0x30);
	LCD_write_char(0x02,LINE1,(read_rtc_code[6]/10)+0x30);
	
	LCD_write_string(0x0d,LINE1,day[read_rtc_code[3]-1]);
	LCD_write_string(0x0d,LINE2,":");
	LCD_write_string(0x0a,LINE2,":");
	LCD_write_string(0x07,LINE1,"-");
	LCD_write_string(0x04,LINE1,"-");
	LCD_write_string(0x00,LINE1,"20");

}
/**************LCD1602ĳʼ***************************/
void LCD_init(void)
{
	LCD_send_command(LCD_DISPLAY_DOUBLE_LINE);
	LCD_send_command(LCD_AC_AUTO_INCREMENT|LCD_MOVE_DISENABLE);
	LCD_send_command(LCD_DISPLAY_ON|LCD_CURSOR_OFF);
	LCD_send_command(LCD_CLEAR_SCREEN);
}
/***********************LCD״̬*********************************/
void LCD_check_busy(void)  
{
	do
	{
		LCD_EN=0;
		LCD_RS=0;
		LCD_RW=1;
		LCDIO=0xff;
		LCD_EN=1;
	}
	while(LCD_BUSY==1);
	
	LCD_EN=0;
}
/************LCD1602д*******************************/
void LCD_send_command(uchar command)
{
	LCD_check_busy();
	LCD_RS=LOW;
	LCD_RW=LOW;
	LCD_EN=HIGH;
	LCDIO=command;
	LCD_EN=LOW;
}
/*****************LCD1602д**************************/
void LCD_send_data(uchar dat)
{
	LCD_check_busy();
	LCD_RS=HIGH;
	LCD_RW=LOW;
	LCD_EN=HIGH;
	LCDIO=dat;
	LCD_EN=LOW;
}
/***********************LCD1602ʾַ*********************************/
void LCD_write_char(uchar x,uchar y,uchar dat)
{
	unsigned char address;
	if (y == LINE1)
		address = LINE1_HEAD + x;
	else
		address = LINE2_HEAD + x;
	LCD_send_command(address);
	LCD_send_data(dat);
}
/******************LCD1602ʾַ*********************/
void LCD_write_string(uchar x,uchar y,uchar *Data)
{
	if(y==LINE1)
	{
		if(x<LINE_LENGTH)
		{
			LCD_send_command(LINE1_HEAD+x);
			for(;x<LINE_LENGTH&&*Data!='\0';x++)
			{
				LCD_send_data(*(Data++));
			}
			if(*Data!='\0')
			{
				x=0;
				y=LINE2;
			}
		}
	}

	if(y==LINE2)
	{
		LCD_send_command(LINE2_HEAD+x);
		for(;x<LINE_LENGTH&&*Data!='\0';x++)
		{
			LCD_send_data(*(Data++));
		}
	}
}
/********************ʱ***********************************/
void delay_ms(uint n)
{
	uint i,j;
	for(i=n;i>0;i--)
		for(j=0;j<1000;j++)
			;
}